/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Cardinality Modifier</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getCardinalityModifier()
 * @model
 * @generated
 */
public enum CardinalityModifier implements Enumerator
{
  /**
   * The '<em><b>CARD 1</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_1_VALUE
   * @generated
   * @ordered
   */
  CARD_1(0, "CARD_1", "CARD_1"),

  /**
   * The '<em><b>CARD 0N</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_0N_VALUE
   * @generated
   * @ordered
   */
  CARD_0N(1, "CARD_0_N", "*"),

  /**
   * The '<em><b>CARD 1N</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_1N_VALUE
   * @generated
   * @ordered
   */
  CARD_1N(2, "CARD_1_N", "+"),

  /**
   * The '<em><b>CARD 01</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_01_VALUE
   * @generated
   * @ordered
   */
  CARD_01(3, "CARD_0_1", "?");

  /**
   * The '<em><b>CARD 1</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_1
   * @model
   * @generated
   * @ordered
   */
  public static final int CARD_1_VALUE = 0;

  /**
   * The '<em><b>CARD 0N</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_0N
   * @model name="CARD_0_N" literal="*"
   * @generated
   * @ordered
   */
  public static final int CARD_0N_VALUE = 1;

  /**
   * The '<em><b>CARD 1N</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_1N
   * @model name="CARD_1_N" literal="+"
   * @generated
   * @ordered
   */
  public static final int CARD_1N_VALUE = 2;

  /**
   * The '<em><b>CARD 01</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #CARD_01
   * @model name="CARD_0_1" literal="?"
   * @generated
   * @ordered
   */
  public static final int CARD_01_VALUE = 3;

  /**
   * An array of all the '<em><b>Cardinality Modifier</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final CardinalityModifier[] VALUES_ARRAY =
    new CardinalityModifier[]
    {
      CARD_1,
      CARD_0N,
      CARD_1N,
      CARD_01,
    };

  /**
   * A public read-only list of all the '<em><b>Cardinality Modifier</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<CardinalityModifier> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Cardinality Modifier</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param literal the literal.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static CardinalityModifier get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      CardinalityModifier result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Cardinality Modifier</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param name the name.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static CardinalityModifier getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      CardinalityModifier result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Cardinality Modifier</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the integer value.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static CardinalityModifier get(int value)
  {
    switch (value)
    {
      case CARD_1_VALUE: return CARD_1;
      case CARD_0N_VALUE: return CARD_0N;
      case CARD_1N_VALUE: return CARD_1N;
      case CARD_01_VALUE: return CARD_01;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private CardinalityModifier(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //CardinalityModifier
